﻿using System;

namespace BbqpCmcs.AtomicOperators
{
	abstract class AtomicOperator
	{
		public abstract void Run(InternalBbqpSolution solution, Random random);

		public string Name { get; set; }
		public abstract bool FindsLocalMinimum { get; }
		public abstract bool CanWorsen { get; }
		public abstract bool IsDeterministicImprovement { get; }
	    public virtual double SlownessWeight { get { return 1; } }

		public virtual bool CanChangeSolution(AtomicOperator prevComponent, bool prevImprovedSolution)
		{
			return true;
		}
	}
}
