﻿using System;
using BbqpCmcs.Types;

namespace BbqpCmcs.AtomicOperators
{
	class MutationX : AtomicOperator
	{
		private readonly int intensity;

		public MutationX(int intensity)
		{
			this.intensity = intensity;
			Name = "MutX" + intensity;
		}

		public override void Run(InternalBbqpSolution solution, Random random)
		{
			var rows = random.DistinctUnordered(solution.Instance.M, intensity);
			
			for (int index = 0; index < rows.Length; index++)
				solution.SetX(rows[index], !solution.GetX(rows[index]));
		}

		public override bool FindsLocalMinimum
		{
			get { return false; }
		}

		public override bool CanWorsen
		{
			get { return true; }
		}

		public override bool IsDeterministicImprovement
		{
			get { return false; }
		}
	}
}
