using System;
using BbqpCmcs.Types;

namespace BbqpCmcs.AtomicOperators
{
	class MutationY : AtomicOperator
	{
		private readonly int intensity;

		public MutationY(int intensity)
		{
			this.intensity = intensity;
			Name = "MutY" + intensity;
		}

		public override void Run(InternalBbqpSolution solution, Random random)
		{
			var cols = random.DistinctUnordered(solution.Instance.N, intensity);
			
			for (int index = 0; index < cols.Length; index++)
				solution.SetY(cols[index], !solution.GetY(cols[index]));
		}

		public override bool FindsLocalMinimum
		{
			get { return false; }
		}

		public override bool CanWorsen
		{
			get { return true; }
		}

		public override bool IsDeterministicImprovement
		{
			get { return false; }
		}
	}
}