﻿using System;

namespace BbqpCmcs.AtomicOperators
{
	class OptimiseX : AtomicOperator
	{
		public OptimiseX()
		{
			Name = "OptX";
		}

		public override void Run(InternalBbqpSolution solution, Random random)
		{
			for (int i = solution.Instance.M - 1; i >= 0; i--)
			{
				var sum = solution.GetRowSum(i);
				if (sum > 0)
					solution.SetX(i, true);
				else if (sum < 0)
					solution.SetX(i, false);
			}
		}

		public override bool FindsLocalMinimum
		{
			get { return true; }
		}

		public override bool CanWorsen
		{
			get { return false; }
		}

		public override bool IsDeterministicImprovement
		{
			get { return true; }
		}

		public override bool CanChangeSolution(AtomicOperator prevComponent, bool prevImprovedSolution)
		{
			if (prevComponent is OptimiseX)
				return false;

			if (prevComponent is FlipY && prevImprovedSolution)
				return false;

			return true;
		}
	}
}
