﻿using System;

namespace BbqpCmcs.AtomicOperators
{
	class OptimiseY : AtomicOperator
	{
		public OptimiseY()
		{
			Name = "OptY";
		}

		public override void Run(InternalBbqpSolution solution, Random random)
		{
			for (int j = solution.Instance.N - 1; j >= 0; j--)
			{
				var sum = solution.GetColSum(j);
				if (sum > 0)
					solution.SetY(j, true);
				else if (sum < 0)
					solution.SetY(j, false);
			}
		}

		public override bool FindsLocalMinimum
		{
			get { return true; }
		}

		public override bool CanWorsen
		{
			get { return false; }
		}

		public override bool IsDeterministicImprovement
		{
			get { return true; }
		}

		public override bool CanChangeSolution(AtomicOperator prevComponent, bool prevImprovedSolution)
		{
			if (prevComponent is OptimiseY)
				return false;

			if (prevComponent is FlipX && prevImprovedSolution)
				return false;

			return true;
		}
	}
}