﻿using System.Collections.Generic;

namespace BbqpCmcs.Types
{
	public abstract class Entity
	{
		public int ID { get; private set; }
		public string UniqueName { get; private set; }
		public string ShortName { get; private set; }

		protected Entity(string uniqueName, string shortName)
		{
			UniqueName = uniqueName;
			ShortName = shortName;
			ID = CreateId(uniqueName);
		}

		private static int lastId = 0;
		private static Dictionary<string, int> ids = new Dictionary<string, int>();

		private static int CreateId(string uniqueName)
		{
			lock (ids)
			{
				int id;
				if (uniqueName == null || !ids.TryGetValue(uniqueName, out id))
				{
					id = ++lastId;
					if (uniqueName != null)
						ids.Add(uniqueName, id);
				}
				return id;
			}
		}

	    public override string ToString()
	    {
	        return UniqueName;
	    }
	}
}
