﻿using System.Collections;
using System.Collections.Generic;

namespace BbqpCmcs.Types
{
	public abstract class Solver<TInstance> : Entity, IEnumerable<Solver<TInstance>>
		where TInstance : Instance
	{
		protected Solver(string uniqueName)
            : this(uniqueName, uniqueName)
		{
		}

		protected Solver(string uniqueName, string shortName)
			: base(uniqueName, shortName)
		{
		}

		public abstract Solution<TInstance> Solve(TInstance instance);

		public IEnumerator<Solver<TInstance>> GetEnumerator()
		{
			yield return this;
		}

		IEnumerator IEnumerable.GetEnumerator()
		{
			return GetEnumerator();
		}

		public virtual bool Cacheable
		{
			get { return true; }
		}

		/// <summary>
		/// Solver that does not require cachine nor printing any debug info -- something like trivial or random construction
		/// </summary>
		public virtual bool IsInstantSolver
		{
			get { return false; }
		}
	}
}
