﻿namespace BbqpCmcs.Types
{
	public class WeightedEntity<T>
	{
		private readonly int weight;
		private readonly T entity;

		public WeightedEntity(T entity, int weight)
		{
			this.weight = weight;
			this.entity = entity;
		}

		public int Weight
		{
			get { return weight; }
		}

		public T Entity
		{
			get { return entity; }
		}

		public override string ToString()
		{
			return string.Format("Weight {0}: {1}", weight, entity);
		}
	}
}
